#
# spec file for package midgard (Version 1.4.2)
#
# Copyright (c) 2002 SuSE Linux AG, Nuernberg, Germany.
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
#
# please send bugfixes or comments to feedback@suse.de.
#

# neededforbuild  apache apache-devel expat freetype2 freetype2-devel gd gd-devel gdbm glib glib-devel imap libjpeg libpng-devel-packages libtiff libz mm mod_php4-core mod_php4-devel mysql-devel mysql-shared openldap2 openldap2-client openldap2-devel xf86 yacc
# usedforbuild    aaa_base aaa_dir aaa_version base bash bindutil bison bzip cpio cpp cyrus-sasl db devs diffutils e2fsprogs file fileutils findutils flex gawk gdbm-devel glibc glibc-devel glibc-locale gpm gppshare grep groff gzip kbd less m4 make man mktemp modutils ncurses ncurses-devel net-tools netcfg pam-devel pam-modules patch ps rcs readline sendmail sh-utils shadow strace syslogd sysvinit texinfo textutils timezone unzip util-linux vim apache apache-devel autoconf automake binutils cracklib expat freetype2 freetype2-devel gcc gd gd-devel gdbm gettext glib glib-devel heimdal-lib imap libjpeg libpng libpng-devel libtiff libtool libz mm mod_php4-core mod_php4-devel mysql-devel mysql-shared openldap2 openldap2-client openldap2-devel pam perl rpm xdevel xf86 xshared yacc

Name:         midgard
%define apache_mmn        %(MMN=$(apxs -q LIBEXECDIR)/MMN; test -x $MMN && $MMN)
%define php_extensiondir  %(/usr/bin/php-config --extension-dir)
%define apache_sysconfdir %(apxs -q SYSCONFDIR)
%define apache_libexecdir %(apxs -q LIBEXECDIR)
%define apache_includedir %(apxs -q INCLUDEDIR)
%define apache_serverroot %(apxs -q PREFIX)
%define apache_docroot    %(apxs -q PREFIX)/htdocs
%define mgd_rel 1
License:      GNU General Public License (GPL) - all versions, Other License(s), see package
Summary:      Web application development and publishing platform
Group:        Productivity/Networking/Web/Frontends
Requires:     apache  mod_php4 perl-DBI perl-Msql-Mysql-modules mysql-client %{apache_mmn}
Autoreqprov:  on
Version:      1.4.2
Release:      231
Source0:      midgard-lib-%{version}-%{mgd_rel}.tar.bz2
Source1:      midgard-data-%{version}-%{mgd_rel}.tar.bz2
Source2:      mod_midgard-%{version}-%{mgd_rel}.tar.bz2
Source3:      midgard-php4-%{version}-%{mgd_rel}.tar.bz2
Source4:      midgard-SuSE-%{version}-%{mgd_rel}.tar.bz2
Patch0:       midgard-lib-%{version}-%{mgd_rel}.diff
Patch1:       midgard-lib-ia64.diff
Patch2:       midgard-SuSEconfig.diff
URL:          http://www.midgard-project.org/
BuildRoot:    %{_tmppath}/%{name}-%{version}-build

%description
Midgard is a freely-available Web application development and
publishing platform based on the popular PHP scripting language. It is
an Open Source development project, giving you the freedom to create
your solutions in an open environment. Midgard is the tool for
creating, modifying and maintaining dynamic database-enabled web
services.

This package includes patched php3-3.0.12. For additional
information about php3 see /usr/share/doc/packages/mod_php.

You can try midgard test site at http://yourhostname:8099.
You can try midgard admin site at http://yourhostname:8101.
Default admin user name is admin, password is password.

SuSE series: n

%prep
%setup -c -n %{name}-%{version} -a 1 -a 2 -a 3 -a 4
%patch
%patch1
%patch2

%build
###############
# docs        #
###############
mv midgard-lib-1.4.2-1/repligard/AUTHORS AUTHORS.repligard
mv midgard-lib-1.4.2-1/AUTHORS AUTHORS.midgard-lib
mv mod_midgard-1.4.2-1/AUTHORS AUTHORS.mod_midgard
mv midgard-lib-1.4.2-1/repligard/ChangeLog ChangeLog.repligard
mv midgard-lib-1.4.2-1/ChangeLog ChangeLog.midgard-lib
mv mod_midgard-1.4.2-1/ChangeLog ChangeLog.mod_midgard
mv midgard-lib-1.4.2-1/NEWS NEWS.midgard-lib
mv midgard-lib-1.4.2-1/repligard/NEWS NEWS.repligard
mv mod_midgard-1.4.2-1/NEWS NEWS.mod_midgard
mv midgard-lib-1.4.2-1/README README.midgard-lib
mv midgard-lib-1.4.2-1/repligard/README README.repligard
mv mod_midgard-1.4.2-1/README README.mod_midgard
###############
# midgard-lib #
###############
cd midgard-lib-%{version}-%{mgd_rel}
libtoolize --force
aclocal
autoconf
./configure --prefix=/usr --sysconfdir=/etc/midgard --with-sitegroups --with-mysql=/usr --with-expat --libdir=%{_libdir}
make
make install
chmod u+x ../midgard-lib-1.4.2-1/midgard-config
###############
# mod_midgard #
###############
cd ../mod_midgard-%{version}-%{mgd_rel}
./configure --with-midgard=/usr --with-mysql=/usr --with-expat=/usr --with-apxs=/usr/sbin/apxs --with-midgard-config=../midgard-lib-1.4.2-1/midgard-config --with-midgard=%{_libdir} --libdir=%{_libdir}
make
###############
# midgard-php #
###############
%{?suse_update_config:%{suse_update_config -f}}
cd ../midgard-php4-%{version}-%{mgd_rel}
rm -f preparser-scanner.c preparser-parser.c preparser-parser.h
/usr/bin/phpize
MIDGARDCONFIG=/usr/bin/midgard-config LDFLAGS=-L%{_libdir} ./configure --with-midgard  --with-php-config=/usr/bin/php-config --libdir=%{_libdir}
make

%install
###############
# SuSE config #
###############
install -d $RPM_BUILD_ROOT/sbin/conf.d
install -m 744 SuSEconfig.midgard $RPM_BUILD_ROOT/sbin/conf.d
##############
# httpd.conf #
##############
install -d $RPM_BUILD_ROOT/%{_var}/adm/fillup-templates
cat<<EOF>$RPM_BUILD_ROOT/%{_var}/adm/fillup-templates/sysconfig.apache-%{name}
#
# enable the %{name} module (yes|no)
#
HTTPD_SEC_MOD_MIDGARD=yes
EOF
install -d $RPM_BUILD_ROOT/%{apache_sysconfdir}/modules
install -m 600 midgard.conf.in $RPM_BUILD_ROOT/%{apache_sysconfdir}
cat<<EOF>$RPM_BUILD_ROOT/%{apache_sysconfdir}/modules/%{name}
Variable:HTTPD_SEC_MOD_MIDGARD
Text:Midgard
LoadModule:LoadModule midgard_module     %{_libdir}/apache/mod_midgard.so
AddModule:AddModule mod_midgard.c
Include:%{apache_sysconfdir}/midgard.conf
EOF
###############
# php.ini     #
###############
###############
# midgard-lib #
###############
cd midgard-lib-%{version}-%{mgd_rel}
make DESTDIR="$RPM_BUILD_ROOT" install
################
# midgard-data #
################
cd ../midgard-data-%{version}-%{mgd_rel}
install -d $RPM_BUILD_ROOT/etc/midgard
cp empty.sql install-repligard.conf Asgard-1.4.1.xml.gz $RPM_BUILD_ROOT/etc/midgard
chmod 600 $RPM_BUILD_ROOT/etc/midgard/install-repligard.conf
install -d $RPM_BUILD_ROOT/usr/local/httpd/htdocs
pushd images
cp -a midgard example $RPM_BUILD_ROOT/usr/local/httpd/htdocs
popd
install -d $RPM_BUILD_ROOT/usr/sbin
cp database-upgrade $RPM_BUILD_ROOT/usr/sbin
###############
# mod_midgard #
###############
cd ../mod_midgard-%{version}-%{mgd_rel}
install -d $RPM_BUILD_ROOT/%{apache_libexecdir}
install -m 644 midgard-root.php $RPM_BUILD_ROOT/%{apache_libexecdir}
install -m 755 mod_midgard.so $RPM_BUILD_ROOT/%{apache_libexecdir}
###############
# midgard-php #
###############
cd ../midgard-php4-%{version}-%{mgd_rel}
install -d $RPM_BUILD_ROOT%{php_extensiondir}
#rm -f modules/*.la
install modules/midgard.so $RPM_BUILD_ROOT%{php_extensiondir}
# move repligard and midgard-config to sbin
mv $RPM_BUILD_ROOT/usr/bin/* $RPM_BUILD_ROOT/usr/sbin
rmdir $RPM_BUILD_ROOT/usr/bin

%post
%{fillup_only -na apache}

%preun
/sbin/conf.d/SuSEconfig.midgard uninstall

%clean
rm -rf $RPM_BUILD_ROOT

%files
%doc AUTHORS.* ChangeLog.* NEWS.* README.*
%{_libdir}/libmidgard.*
/usr/share/midgard
/etc/midgard
/usr/sbin/*
%attr(700, root, root) /sbin/conf.d/SuSEconfig.midgard
%{apache_libexecdir}/*
%{apache_sysconfdir}/modules/*
%{apache_sysconfdir}/midgard.conf.in
%{php_extensiondir}/*
%{apache_docroot}/midgard
%{apache_docroot}/example
%{_var}/adm/fillup-templates/sysconfig.apache-%{name}

%changelog -n midgard
* Sat Jul 20 2002 - poeml@suse.de
- detect the module magic number if provided by apache, indicating
  API changes, and add an RPM Require on it
- remove hard RPM dependancy on Apache's %%{release} tag
* Mon Mar 04 2002 - tcrhak@suse.cz
- In SuSEconfig.midgard: if midgard.conf.in does not exist, just exit;
  set permissions of /etc/httpd/midgard.conf to 600
* Tue Feb 19 2002 - tcrhak@suse.cz
- fixed midgard.conf and SuSEconfig.midgard to behave correctly
  during update and to read hostname from /etc/HOSTNAME
* Fri Feb 01 2002 - ro@suse.de
- changed neededforbuild <libpng> to <libpng-devel-packages>
* Fri Jan 18 2002 - tcrhak@suse.cz
- added mysql-client to requires
- SuSEconfig.midgard: delete midgard user when uninstolling,
- test midgard db existence via mysql client
- use %%{_lib}/%%{_libdir} macros
* Fri Jan 11 2002 - tcrhak@suse.cz
- used fillup_only macro
* Tue Dec 18 2001 - tcrhak@suse.cz
- patched acinclude.m4 to find a correct dir for mysql libraries
* Wed Dec 12 2001 - tcrhak@suse.cz
- update to version 1.4.2
* Thu Nov 08 2001 - ro@suse.de
- use -a for automake
* Wed Aug 22 2001 - ro@suse.de
- removed another hardcoded reference for pdflib in specfile
* Wed Aug 22 2001 - ro@suse.de
- removed pdflib from neededforbuild (license problems)
* Thu Jul 26 2001 - kukuk@suse.de
- fix needed for build
* Fri Jun 22 2001 - ro@suse.de
- fixed for new autoconf
* Wed Jun 06 2001 - pblaha@suse.cz
- fix cast pointer on ia64
* Thu May 17 2001 - pblaha@suse.cz
- rename in midgard.spec:%%ifarch ! axp  to alpha
* Fri May 04 2001 - pblaha@suse.cz
- add  AddType application/x-httpd-php3 .php3 in SuSEconfig.midgard
* Tue May 01 2001 - kukuk@suse.de
- disable adabas support
* Wed Apr 04 2001 - rolf@suse.de
- added /var/adm/fillup-templates/apache-midgard.rc.config
- added /etc/httpd/modules/midgard
- added Conflicts: mod_php mod_php4
* Thu Mar 22 2001 - ro@suse.de
- update to 1.4
- use freetype2
* Thu Mar 15 2001 - ro@suse.de
- changed to openldap2
* Thu Mar 15 2001 - ro@suse.de
- fixed neededforbuild for openldap
* Fri Feb 23 2001 - ro@suse.de
- changed neededforbuild <apache> to <apache apache-devel>
* Thu Jan 11 2001 - pblaha@suse.cz
- fix bug describied http://midgard.teamlinux.de/news/9133.html
- move midgard-root.php3 to /usr/local/httpd/htdocs/midgard/
- update SuSEconfig.midgard
* Wed Nov 29 2000 - ro@suse.de
- changed neededforbuild <pg_lib> to <postgresql-lib>
* Wed Nov 15 2000 - ro@suse.de
- fixed neededforbuild gdlib -> gd gd-devel
* Mon Nov 06 2000 - ro@suse.de
- fixed neededforbuild
* Mon Sep 18 2000 - bubnikv@suse.cz
- fixed path in generation of midgard.conf in SuSEconfig.midgard
- added midgard.conf as ghost configuration file to file list
* Tue Jul 25 2000 - bubnikv@suse.cz
- /usr/lib/midgard{.so,so.x} should be links; fixed
- added test, if apache is able to load midgard modules
* Tue Jul 18 2000 - bubnikv@suse.cz
- put -I. as the first include path for midgard-php3 compilation
  (it took config.h from other place before)
* Mon Jul 10 2000 - bubnikv@suse.cz
- return 0 changed to exit 0 at the end of SuSEconfig.midgard
* Fri Jul 07 2000 - kukuk@suse.de
- Fix Requires and need for build
* Thu Jun 29 2000 - ro@suse.de
- changed requires pg_ifa -> postgres
* Mon Jun 26 2000 - uli@suse.de
- midgard-lib needs to link libm (fixes problem on PPC, and most
  probably on SPARC, too)
* Fri Jun 16 2000 - bubnikv@suse.cz
- fixed for new postgres
* Fri May 26 2000 - bubnikv@suse.cz
- sorted
* Thu May 11 2000 - bubnikv@suse.cz
- modified SuSEconfig.midgard
* Fri Apr 28 2000 - bubnikv@suse.cz
- added package
